<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <style>
        .btn-box {
            display: flex;
        }
    </style>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <button onclick="onBtnCreateOrderClick()" class="btn btn-success">Thêm đơn hàng</button>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        //column number
        const gEND_ROW_TABLE = -1;
        const gCOLUMN_ORDER_CODE = 0;
        const gCOLUMN_COMBO_SIZE = 1;
        const gCOLUMN_TYPE = 2;
        const gCOLUMN_DRINK = 3;
        const gCOLUMN_SUM_AMOUNT = 4;
        const gCOLUMN_FULL_NAME = 5;
        const gCOLUMN_PHONE_NUMBER = 6;
        const gCOLUMN_STATUS = 7;
        const gCOLUMN_DETAIL = 8;

        const gDETAIL_FORM_URL = "orderDetail.html";
        const gINDEX_LIST_URL = "indexListView.html";
        const gCREATE_ORDER_URL = "create.order.html";

        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
        const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }
        // hàm xử lý nút detail
        function onBtnDetailClick(paramButton) {
            console.log("Order Code: " + paramButton.dataset.ordercode);
            console.log("Id: " + paramButton.dataset.id);
            // Task 31.20
            // thu thap du lieu
            var vId = paramButton.dataset.id;
            var vOrderCode = paramButton.dataset.ordercode;
            // goi va truyen qua data form

            var vUrlSiteToOpen = gDETAIL_FORM_URL 
            +
            "?id=" + vId +
            "&ordercode=" + vOrderCode;
            window.location.href = vUrlSiteToOpen;
        }
        function onBtnDeleteClick(paramButton) {
            if (confirm("Bạn có chắc chắn muốn xóa đơn hàng này không?")) {
                console.log("Gọi hàm xóa đơn hàng!");
                deleteOrder(paramButton);
            } else {
                console.log("Đơn hàng được giữ lại!");
            }
        }
        function onBtnCreateOrderClick() {
            var vUrlSiteToOpen = gCREATE_ORDER_URL;
            window.location.href = vUrlSiteToOpen;
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm Xóa đơn hàng
        function deleteOrder(paramButton) {
            // b1: thu thập dữ liệu: id đơn hàng
            var vOrderId = paramButton.dataset.id;
            // b2: kiểm tra dữ liệu
            if (vOrderId == null) {
                console.log("id chưa được ghi nhận vào nút delete");
            } else {
                console.log("Tiến hành xóa đơn hàng");
                // b3: xử lý ajax
                var vXmlHttpDeleteOrder = new XMLHttpRequest();
                processAPIDeleteOrder(vXmlHttpDeleteOrder, vOrderId);
                // b4: xử lý hiển thị
                vXmlHttpDeleteOrder.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK 
                        && this.status == gREQUEST_DELETE_SUCCESS) {
                        console.log("Tiến hành phân tích responseText");
                        resultDeleteOrder(vXmlHttpDeleteOrder);
                    }
                }
            }
        }

        // hàm xử lý ajax delete order
        function processAPIDeleteOrder(paramXHTMLRequest, paramId) {
            paramXHTMLRequest.open("DELETE", vBASE_URL + "/" + paramId, true);
            paramXHTMLRequest.send();
        }
        // hàm kiểm tra kết quả hoạt động xóa đơn hàng
        function resultDeleteOrder(paramXHTMLRequest) {
            var vResponseTextDelete = paramXHTMLRequest.responseText;
            if (vResponseTextDelete == "") {
                alert("Đã xóa đơn hàng thành công!");
                location.reload()
            } else {
                alert("Hoạt động xóa đơn hàng bị lỗi!")
            }
        }
        
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vTable = document.getElementById("table-order");
            var vTableBody = vTable.getElementsByTagName("tbody")[0];
            var vOrderObj = JSON.parse(paramXMLHttpAllOrder.responseText);
            for (let i = 0; i < vOrderObj.length; i++) {
                var vOrder = vOrderObj[i];
                // tạo hàng
                var vNewRow = vTableBody.insertRow(gEND_ROW_TABLE);
                // tạo cell
                var vCellOrderCode = vNewRow.insertCell(gCOLUMN_ORDER_CODE);
                var vCellComboSize = vNewRow.insertCell(gCOLUMN_COMBO_SIZE);
                var vCellPizzaType = vNewRow.insertCell(gCOLUMN_TYPE);
                var vCellDrink = vNewRow.insertCell(gCOLUMN_DRINK);
                var vCellSumAmount = vNewRow.insertCell(gCOLUMN_SUM_AMOUNT);
                var vCellFullName = vNewRow.insertCell(gCOLUMN_FULL_NAME);
                var vCellPhoneNumber = vNewRow.insertCell(gCOLUMN_PHONE_NUMBER);
                var vCellStaTus = vNewRow.insertCell(gCOLUMN_STATUS);
                var vCellDetail = vNewRow.insertCell(gCOLUMN_DETAIL);
                // thêm nội dụng vào cell
                vCellOrderCode.innerHTML = vOrder.orderCode;
                vCellComboSize.innerHTML = vOrder.kichCo;
                vCellPizzaType.innerHTML = vOrder.loaiPizza;
                vCellDrink.innerHTML = vOrder.idLoaiNuocUong;
                vCellSumAmount.innerHTML = vOrder.thanhTien;
                vCellFullName.innerHTML = vOrder.hoTen;
                vCellPhoneNumber.innerHTML = vOrder.soDienThoai;
                vCellStaTus.innerHTML = vOrder.trangThai;

                var vDetailButton = document.createElement("button");
                vDetailButton.className = "btn btn-info";
                vDetailButton.innerHTML = "Chi tiết";
                vDetailButton.setAttribute("data-id", vOrder.id);
                vDetailButton.setAttribute("data-ordercode", vOrder.orderCode);
                vDetailButton.addEventListener("click", function(){
                    onBtnDetailClick(this);
                });

                var vDeleteButton = document.createElement("button");
                vDeleteButton.className = "btn btn-danger";
                vDeleteButton.innerHTML = "Delete";
                vDeleteButton.setAttribute("data-id", vOrder.id);
                vDeleteButton.addEventListener("click", function(){
                    onBtnDeleteClick(this);
                });

                vCellDetail.append(vDetailButton);
                vCellDetail.append(vDeleteButton);
                vCellDetail.className = "btn-box";

                // vCellDetail.innerHTML = `
                //     <button 
                //         class = "btn btn-info"
                //         data-ordercode = "${vOrder.orderCode}"
                //         data-id = "${vOrder.id}"
                //         onclick="onBtnDetailClick(this)"
                //     >
                //         Chi tiết
                //     </button>

                // `;

            }
        }


    </script>
</body>

</html>